import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

import java.awt.Font;
import java.awt.Color;

/**
 * Counter that displays a number.
 * 
 * @author Michael Kolling
 * @version 1.0.1
 */
public class Counter extends Actor
{
    private int value = 0;
//    private int target = 20;
    private String text;
    private int stringLength;

    private boolean fUpdate = true;
    
    public Counter()
    {
        this("");
    }

    public Counter(String prefix)
    {
        text = prefix;
        stringLength = (text.length() + 5) * 16;

        setImage(new GreenfootImage(stringLength, 24));
        GreenfootImage image = getImage();
        Font font = image.getFont();
        image.setFont(font.deriveFont(24.0F));  // use larger font
        
        updateImage();
    }
    
    public void act() {
          value = ((MyWorld)getWorld()).nbCliques;
          //value = MangeWorld.ours.nbDeplacement; // OK si ours est static
          updateImage();
    }

    public int getValue()
    {
        return value;
    }

    /**
     * Make the image
     */
    private void updateImage()
    {
        if (!fUpdate) return;
        
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + value, 1, 18);
    }

    /**
     * Make the score board image.
     */
    public void makeImage(String title, String prefix, int score)
    {
        int WIDTH = 400;
        int HEIGHT = 300;
        float FONT_SIZE = 24.0f;

        setLocation(4, 4);
        GreenfootImage image = new GreenfootImage(WIDTH, HEIGHT);

        image.setColor(new Color(0, 0, 0));
        image.fillRect(0, 0, WIDTH, HEIGHT);
        image.setColor(new Color(255, 255, 255));
        image.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = image.getFont();
        font = font.deriveFont(FONT_SIZE);
        image.setFont(font);
//        image.setColor(Color.WHITE);
        image.setColor(Color.BLACK);
        image.drawString(title, 30, 100);
        image.drawString(prefix + score, 30, 200);
        setImage(image);
        fUpdate = false;
    }

}
